﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using WPF_Wii_Binding_Library;

namespace Library_Testing
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private MouseSource mouseSource;
        private WiiSource wiiSource;
        private Pairing pairing;
        private FingerBinding binding;

        public Window1()
        {
            InitializeComponent();
            binding = (FingerBinding)FindResource("FingerData");
            try
            {
                wiiSource = new WiiSource();
                wiiSource.Start();
                pairing = new Pairing(wiiSource, binding);
            }
            catch (Exception)
            {
                mouseSource = new MouseSource();
                pairing = new Pairing(mouseSource, binding);
            }
        }

        private void Window_MouseMove(object sender, MouseEventArgs e) {
            Point p = Mouse.GetPosition(this);
            if (mouseSource != null) mouseSource.InjectMouseMove((float)(1.0f - p.X / Width), (float)(1.0 - p.Y / Height));
        }

        private void Window_MouseRightButtonUp(object sender, MouseButtonEventArgs e) {
            if (mouseSource != null) mouseSource.InjectRightClick();
        }

        private void Window_MouseWheel(object sender, MouseWheelEventArgs e) {
            if (mouseSource != null) mouseSource.InjectMouseWheel(e.Delta);
        }

        private void Window_KeyUp(object sender, KeyEventArgs e) {
            if (mouseSource != null) mouseSource.InjectKey(e.Key);
        }

        private void Window_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            binding.CanvasHeight = e.NewSize.Height;
            binding.CanvasWidth = e.NewSize.Width;
        }

    }
}
