﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows; 


namespace WPF_Wii_Binding_Library {
    public class FingerBinding : INotifyPropertyChanged {
#region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

#endregion


#region Private Members
        private Point[] fingerPos = new Point[4] {new Point(0, 0),
            new Point(0,50), new Point(50, 50), new Point(0, 50) };
        private double[] fingerSize = new double[4] { 30, 30, 30, 30 };
        private bool[] fingerVisible = new bool[4] { false, false, false, false };
#endregion

#region Canvas Properties
        ///<summary>
        /// Holder for Canvas Data
        /// </summary>
        double canvasWidth;

        public double CanvasWidth {
            get { return this.canvasWidth; }
            set {
                if (this.canvasWidth == value) { return; }
                this.canvasWidth = value;
                Notify("CanvasWidth");
            }
        }

        double canvasHeight;

        public double CanvasHeight {
            get { return this.canvasHeight; }
            set {
                if (this.canvasHeight == value) { return; }
                this.canvasHeight = value;
                Notify("CanvasHeight");
            }
        }
#endregion

#region Public Members
        public FingerBinding() {
        }

        public bool P1F1Visible
        {
            get { return fingerVisible[0]; }
            set
            {
                if (value == fingerVisible[0]) return;
                fingerVisible[0] = value;
                Notify("P1F1Visible");
            }
        }

        public double P1F1Size
        {
            get { return fingerSize[0]; }
            set
            {
                if (value == fingerSize[0]) return;
                fingerSize[0] = value;
                Notify("P1F1Size");
            }
        }

        public Point P1F1Position {
            get { return fingerPos[0]; }
            set {
                if (value == fingerPos[0]) return;
                fingerPos[0] = value;
                Notify("P1F1Position");
            }
        }

        public bool P1F2Visible
        {
            get { return fingerVisible[1]; }
            set
            {
                if (value == fingerVisible[1]) return;
                fingerVisible[1] = value;
                Notify("P1F2Visible");
            }
        }
        
        public double P1F2Size
        {
            get { return fingerSize[1]; }
            set
            {
                if (value == fingerSize[1]) return;
                fingerSize[1] = value;
                Notify("P1F2Size");
            }
        }

        public Point P1F2Position {
            get { return fingerPos[1]; }
            set {
                if (value == fingerPos[1]) return;
                fingerPos[1] = value;
                Notify("P1F2Position");
            }
        }

        public bool P2F1Visible
        {
            get { return fingerVisible[2]; }
            set
            {
                if (value == fingerVisible[2]) return;
                fingerVisible[2] = value;
                Notify("P2F1Visible");
            }
        }

        public double P2F1Size
        {
            get { return fingerSize[2]; }
            set
            {
                if (value == fingerSize[2]) return;
                fingerSize[2] = value;
                Notify("P2F1Size");
            }
        }

        public Point P2F1Position {
            get { return fingerPos[2]; }
            set {
                if (value == fingerPos[2]) return;
                fingerPos[2] = value;
                Notify("P2F1Position");
            }
        }

        public bool P2F2Visible
        {
            get { return fingerVisible[3]; }
            set
            {
                if (value == fingerVisible[3]) return;
                fingerVisible[3] = value;
                Notify("P2F2Visible");
            }
        }

        public double P2F2Size
        {
            get { return fingerSize[3]; }
            set
            {
                if (value == fingerSize[3]) return;
                fingerSize[3] = value;
                Notify("P2F2Size");
            }
        }
        public Point P2F2Position {
            get { return fingerPos[3]; }
            set {
                if (value == fingerPos[3]) return;
                fingerPos[3] = value;
                Notify("P2F2Position");
            }
        }

#endregion

        //Property changed
        protected void Notify(string propName) {
            if (this.PropertyChanged != null) {
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
            }
        }


    }
}
