﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WiimoteLib;

namespace WPF_Wii_Binding_Library
{
    public class WiiSource : IInputSource {
#region Private members
        Wiimote wii;
        IRSensor[] state;
#endregion

        public WiiSource() {

        }
        ~WiiSource() {
            Stop();
        }

#region IInputSource Members

        public event InputChangedEventHandler InputChanged;

        WiimoteLib.IRSensor[] IInputSource.GetData() {
            return state;
        }

#endregion

#region Public methods

        //Initialize wii
        public void Start() {
            wii = new Wiimote();
            wii.WiimoteChanged += UpdateWiimoteState;
            wii.Connect();
            wii.SetReportType(InputReport.IRAccel, true);
            wii.SetLEDs(false, true, true, false);
        }

        public void Stop() {
            if(wii != null) wii.Disconnect();
        }

#endregion

#region Private methods
        private void UpdateWiimoteState(object sender, WiimoteChangedEventArgs args) {
            state = args.WiimoteState.IRState.IRSensors;
            if (InputChanged != null) InputChanged();
        }
#endregion
    }
}
